--- r.watershed2.orig/ram/close_maps.c	2008-11-29 11:45:15.000000000 +0100
+++ r.watershed2/ram/close_maps.c	2008-12-02 11:11:59.000000000 +0100
@@ -9,6 +9,8 @@
     struct Colors colors;
     int value, r, c, fd;
     CELL *buf = NULL;
+    struct Range accRange;
+    CELL min, max;
 
     if (wat_flag || asp_flag || dis_flag || ls_flag || sl_flag || sg_flag)
 	buf = G_allocate_cell_buf();
@@ -30,6 +32,43 @@
 	    }
 	    if (G_close_cell(fd) < 0)
 		G_warning(_("Close failed."));
+
+        /*
+           color rules for flow accumulation
+             0% black
+           -200 black
+           -150 blue
+            -40 cyan
+            -20 green
+              0 yellow
+             20 green
+             40 cyan
+            150 blue
+            200 black
+           100% black
+        */
+
+	    G_read_range(wat_name, this_mapset, &accRange);
+	    min = max = 0;
+	    G_get_range_min_max(&accRange, &min, &max);
+
+	    G_init_colors(&colors);
+	    if (min < -200)
+		G_add_color_rule(min, 0, 0, 0, -200, 0, 0, 0, &colors);
+
+	    G_add_color_rule(-200, 0, 0, 0, -150, 0, 0, 255, &colors);
+	    G_add_color_rule(-150, 0, 0, 255, -40, 0, 255, 255, &colors);
+	    G_add_color_rule(-40, 0, 255, 255, -20, 0, 255, 0, &colors);
+	    G_add_color_rule(-20, 0, 255, 0, 0, 255, 255, 0, &colors);
+	    G_add_color_rule(0, 255, 255, 0, 20, 0, 255, 0, &colors);
+	    G_add_color_rule(20, 0, 255, 0, 40, 0, 255, 255, &colors);
+	    G_add_color_rule(40, 0, 255, 255, 150, 0, 0, 255, &colors);
+	    G_add_color_rule(150, 0, 0, 255, 200, 0, 0, 0, &colors);
+
+	    if (max > 200)
+		G_add_color_rule(200, 0, 0, 0, max, 0, 0, 0, &colors);
+
+	    G_write_colors(wat_name, this_mapset, &colors);
 	}
     }
 
